function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)");
    var results = regex.exec(document.location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

window.onload = function() {
    var lang = getParameterByName("lang");
    var errorCode = getParameterByName("error") || "general";
    var errorTranslations = window.translations[lang] || window.translations["en"];
    var t = errorTranslations[errorCode] || errorTranslations["general"];

    document.getElementById("error-header").innerHTML = t["error-header"];
    document.getElementById("error-row1").innerHTML = t["error-row1"];
    document.getElementById("error-row2").innerHTML = t["error-row2"];
    document.getElementById("error-button").innerHTML = t["error-button"];
};
