// Bootstrap script to load app config and then loading app
/*************************************************************************************************************
 * NOTE: Think twice before adding functionality in this file. Consider adding it to NativeSetup.js instead. *
 *************************************************************************************************************/
// Replaced by build script
/* eslint-disable */
var appId = "3cf7de02d3db62d34664b61d889cb12c"; // DO_NOT_MODIFY
/* eslint-enable */
var backend = "https://companion.battlefield.com"; // DO_NOT_MODIFY
if (localStorage.getItem("backendOverride") !== null) {
    backend = localStorage.getItem("backendOverride");
}

// Override default back button functionality to prevent potential crashes when user clicks back during app load
document.addEventListener("backbutton", function() {}, false);

window.SC = {
    backend: backend,
    personas: [],
    showErrorPage: function(error) {
        // Always hide the splash
        if (navigator.splashscreen) {
            navigator.splashscreen.hide();
        }

        // If locale and phoneLocale are not set (happens if this function is called before initApp), we fallback to
        // getPhoneLocale function
        var locale = SC.locale || SC.phoneLocale || getPhoneLocale().replace("-", "_");

        // Special handling for mexican spanish
        var language = locale === "es_MX" ? "mx" : locale.split("_")[0];

        var routeBase = document.location.pathname.split("index.html")[0];
        document.location.href = routeBase + "error.html?error=" + error + "&lang=" + language;
    },

    reloadApp: function() {
        // Special handling to get app reload work, index.html/x/y/z doesn't load in native app
        // Save previous path in hash for later redirect
        history.replaceState({}, "", document.location.pathname.replace("index.html", "index.html#"));
        document.location.reload();
    }
};

/* eslint-disable */
var resetOverrides = function() {
    localStorage.removeItem("backendOverride");
    localStorage.removeItem("frontendOverride");
    SC.reloadApp();
};
/* eslint-enable */

var loadScript = function(url, onload, onerror) {
    var script = document.createElement("script");
    script.onload = function() {
        onload();
    };
    script.onerror = function() {
        onerror();
    };
    script.src = url;
    document.head.appendChild(script);
};

// http://stackoverflow.com/questions/1043339/javascript-for-detecting-browser-language-preference
var getPhoneLocale = function() {
    var locale = "";

    try {
        locale = (navigator.languages && navigator.languages[0]) || navigator.language || navigator.userLanguage;
    } catch (e) {
        console.log("Could not get the system language", e);
    }

    return locale;
};

var initScriptUrl = backend + "/companion/init.js";

var loadBundleAndInitApp = function() {
    loadScript(
        initScriptUrl,
        function() {
            var SC = window.SC;

            var locale = getPhoneLocale().toLowerCase();

            // Map system language to locale (map comes from backend)
            var language = locale.split("-")[0];
            var localeMapping = SC.localeMapping || {};
            var pulseLocaleMapping = SC.pulseLocaleMapping || {};

            // First try to map language to a supported language, then locale. Fallback to en_US
            SC.phoneLocale = pulseLocaleMapping[locale] || localeMapping[language];

            if (document.location.hash) {
                history.replaceState({}, "", document.location.pathname + document.location.hash.substr(1));
            }
            window.SC.initApp(backend, "mobile");
        },
        function() {
            window.SC.showErrorPage("general");
        }
    );
};

document.addEventListener("deviceready", function() {
    // Check if we're connected to the interweb
    if (navigator.connection && window.Connection) {
        var networkState = navigator.connection.type;
        if (networkState === window.Connection.NONE) {
            window.SC.showErrorPage("noconnection");
            return;
        }
    }

    loadBundleAndInitApp();
});
